/* (C) 2009-2011 Yana */

#if !defined(Y_YK0A_H)
#define Y_YK0A_H

#include "y_base.h"

#if !defined(Y_PREPROCESS_ONLY)

#include "yk0a.h"
#include <stddef.h>

__inline__ static void y_yk0a_start(yk0a_task_t task, void (*pc)(void), void *sp, yk0a_context_value_t spsr) {
	yk0a_set_context(task, YK0A_CONTEXT_R13, (yk0a_context_value_t)sp, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_R14, (yk0a_context_value_t)pc, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_R15, (yk0a_context_value_t)pc, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_SPSR, spsr, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_CPSR, 0, NULL);
	yk0a_reply(task);
}

#endif

#endif
