/* (C) 2009-2011 Yana */

#if !defined(Y_YK0A_H)
#define Y_YK0A_H

#include "y_base.h"

#if !defined(Y_PREPROCESS_ONLY)

#include "yk0a.h"
#include <stddef.h>

__inline__ static void y_yk0a_start(yk0a_task_t task, void (*pc)(void), void *sp, void *gp, yk0a_context_value_t status) {
	yk0a_set_context(task, YK0A_CONTEXT_EPC, (yk0a_context_value_t)pc, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_GPR28, (yk0a_context_value_t)gp, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_GPR29, (yk0a_context_value_t)sp, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_GPR31, (yk0a_context_value_t)pc, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_STATUS, status, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_CAUSE, 0, NULL);
	yk0a_reply(task);
}

#endif

#endif
