/* (C) 2011 Yana */

#define YK0A_PREPROCESS_ONLY

#if defined(YK0A_CUSTOM_DISABLE_ASM)

#include "yk0a.h"
#include "yk0a_interrupt.h"

	.text
	.balign 4

	.global yk0a_accept
yk0a_accept:
	mov r2, r1
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_ACCEPT
	swi 0
	cmp r2, #0
	beq yk0a_accept_0
	str r1, [r2]
yk0a_accept_0:
	mov pc, lr

	.global yk0a_bit_flag
yk0a_bit_flag:
	mov r12, r3
	mov r3, r2
	mov r2, r1
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_BIT_FLAG
	swi 0
	cmp r12, #0
	beq yk0a_bit_flag_0
	str r1, [r12]
yk0a_bit_flag_0:
	mov pc, lr

	.global yk0a_call
yk0a_call:
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_CALL
	swi 0
	mov pc, lr

	.global yk0a_connect
yk0a_connect:
	mov r2, r1
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_CONNECT
	swi 0
	mov pc, lr

	.global yk0a_forward
yk0a_forward:
	mov r2, r1
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_FORWARD
	swi 0
	mov pc, lr

	.global yk0a_get_context
yk0a_get_context:
	mov r3, r2
	mov r2, r1
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_GET_CONTEXT
	swi 0
	cmp r3, #0
	beq yk0a_get_context_0
	str r1, [r3]
yk0a_get_context_0:
	mov pc, lr

	.global yk0a_get_priority
yk0a_get_priority:
	mov r2, r1
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_GET_PRIORITY
	swi 0
	cmp r2, #0
	beq yk0a_get_priority_0
	str r1, [r2]
yk0a_get_priority_0:
	mov pc, lr

	.global yk0a_listen
yk0a_listen:
	mov r3, r2
	mov r2, r1
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_LISTEN
	swi 0
	cmp r3, #0
	beq yk0a_listen_0
	str r1, [r3]
yk0a_listen_0:
	mov pc, lr

	.global yk0a_reply
yk0a_reply:
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_REPLY
	swi 0
	mov pc, lr

	.global yk0a_set_context
yk0a_set_context:
	mov r12, r3
	mov r3, r2
	mov r2, r1
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_SET_CONTEXT
	swi 0
	cmp r12, #0
	beq yk0a_set_context_0
	str r1, [r12]
yk0a_set_context_0:
	mov pc, lr

	.global yk0a_set_priority
yk0a_set_priority:
	mov r3, r2
	mov r2, r1
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_SET_PRIORITY
	swi 0
	cmp r3, #0
	beq yk0a_set_priority_0
	str r1, [r3]
yk0a_set_priority_0:
	mov pc, lr

	.global yk0a_get_flag
yk0a_get_flag:
	mov r3, r1
	mov r2, #0
	mov r1, #0
	b yk0a_bit_flag

	.global yk0a_set_flag
yk0a_set_flag:
	mov r3, r2
	mov r2, r1
	mvn r1, #0
	b yk0a_bit_flag

	.global yk0a_interrupt_bit_mask
yk0a_interrupt_bit_mask:
	mov r3, r2
	mov r2, r1
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_INTERRUPT_BIT_MASK
	swi 0
	cmp r3, #0
	beq yk0a_interrupt_bit_mask_0
	str r1, [r3]
yk0a_interrupt_bit_mask_0:
	mov pc, lr

	.global yk0a_interrupt_bit_request
yk0a_interrupt_bit_request:
	mov r3, r2
	mov r2, r1
	mov r1, r0
	mov r0, #YK0A_PROCEDURE_INTERRUPT_BIT_REQUEST
	swi 0
	cmp r3, #0
	beq yk0a_interrupt_bit_request_0
	str r1, [r3]
yk0a_interrupt_bit_request_0:
	mov pc, lr

#endif
