/* (C) 2011 Yana */

#define YK0A_PREPROCESS_ONLY

#if defined(YK0A_CUSTOM_DISABLE_ASM)

#include "yk0a.h"
#include "yk0a_interrupt.h"

	.text
	.balign 4
	.set at
	.set reorder

	.global yk0a_accept
yk0a_accept:
	li $2, YK0A_PROCEDURE_ACCEPT
	move $3, $4
	syscall
	beq $5, $0, yk0a_accept_0
	sw $3, ($5)
yk0a_accept_0:
	jr $ra

	.global yk0a_bit_flag
yk0a_bit_flag:
	li $2, YK0A_PROCEDURE_BIT_FLAG
	move $3, $4
	move $4, $5
	move $5, $6
	syscall
	beq $7, $0, yk0a_bit_flag_0
	sw $3, ($7)
yk0a_bit_flag_0:
	jr $ra

	.global yk0a_call
yk0a_call:
	li $2, YK0A_PROCEDURE_CALL
	move $3, $4
	syscall
	jr $ra

	.global yk0a_connect
yk0a_connect:
	li $2, YK0A_PROCEDURE_CONNECT
	move $3, $4
	move $4, $5
	syscall
	jr $ra

	.global yk0a_forward
yk0a_forward:
	li $2, YK0A_PROCEDURE_FORWARD
	move $3, $4
	move $4, $5
	syscall
	jr $ra

	.global yk0a_get_context
yk0a_get_context:
	li $2, YK0A_PROCEDURE_GET_CONTEXT
	move $3, $4
	move $4, $5
	syscall
	beq $6, $0, yk0a_get_context_0
	sw $3, ($6)
yk0a_get_context_0:
	jr $ra

	.global yk0a_get_priority
yk0a_get_priority:
	li $2, YK0A_PROCEDURE_GET_PRIORITY
	move $3, $4
	syscall
	beq $5, $0, yk0a_get_priority_0
	sw $3, ($5)
yk0a_get_priority_0:
	jr $ra

	.global yk0a_listen
yk0a_listen:
	li $2, YK0A_PROCEDURE_LISTEN
	move $3, $4
	move $4, $5
	syscall
	beq $6, $0, yk0a_listen_0
	sw $3, ($6)
yk0a_listen_0:
	jr $ra

	.global yk0a_reply
yk0a_reply:
	li $2, YK0A_PROCEDURE_REPLY
	move $3, $4
	syscall
	jr $ra

	.global yk0a_set_context
yk0a_set_context:
	li $2, YK0A_PROCEDURE_SET_CONTEXT
	move $3, $4
	move $4, $5
	move $5, $6
	syscall
	beq $7, $0, yk0a_set_context_0
	sw $3, ($7)
yk0a_set_context_0:
	jr $ra

	.global yk0a_set_priority
yk0a_set_priority:
	li $2, YK0A_PROCEDURE_SET_PRIORITY
	move $3, $4
	move $4, $5
	syscall
	beq $6, $0, yk0a_set_priority_0
	sw $3, ($6)
yk0a_set_priority_0:
	jr $ra

	.global yk0a_get_flag
yk0a_get_flag:
	move $7, $5
	move $6, $0
	move $5, $0
	b yk0a_bit_flag

	.global yk0a_set_flag
yk0a_set_flag:
	move $7, $6
	move $6, $5
	li $5, ~0
	b yk0a_bit_flag

	.global yk0a_interrupt_bit_mask
yk0a_interrupt_bit_mask:
	li $2, YK0A_PROCEDURE_INTERRUPT_BIT_MASK
	move $3, $4
	move $4, $5
	syscall
	beq $6, $0, yk0a_interrupt_bit_mask_0
	sw $3, ($6)
yk0a_interrupt_bit_mask_0:
	jr $ra

	.global yk0a_interrupt_bit_request
yk0a_interrupt_bit_request:
	li $2, YK0A_PROCEDURE_INTERRUPT_BIT_REQUEST
	move $3, $4
	move $4, $5
	syscall
	beq $6, $0, yk0a_interrupt_bit_request_0
	sw $3, ($6)
yk0a_interrupt_bit_request_0:
	jr $ra

#endif
